Projectiles = {}
PLAYERS = {}
COLOUR = { -- colours. it's usage: "..COLOUR[1].." for example..i am using it for all my scripts :P
	"\169255220000", -- CS2D (yellow) 1 
	"\169255255255", -- white 2
	"\169255000000", -- red 3
	"\169000255000", -- green 4
	"\169000000255", -- blue 5
	"\169200200200", -- light grey 6
	"\169064179162", -- PM - light blue 7
	"\169255025000", -- T 8
	"\169050150255", -- CT 9
	"\169100100100", -- pretty dark grey - tag 10
	"\169015200015", -- vip 11 
	"\169155195255", -- trainee 12 
	"\169050129255", -- mod 13 
	"\169087000127", -- supporter 14 
	"\169255106000", -- admin 15 
	"\169255241234", -- owner 16
	"\169255195100", -- premium gold 17
	"\169200255020", -- nice green 18
	"\169090128255", -- nice blue 19 / water
	"\169255128090", -- nice red 20
	"\169255128000", -- orange 21
	"\169050150050", -- darkly green 22
	"\169149149044", -- molotovy 23
	"\169230020020", -- gutty 24
	"\169200255200", -- satchely 25
	"\169150255150", -- cute green 26
	"\169255174095", -- cute orange 27
	"\169216184162", -- kyznec 28
	"\169255174110", -- engineer 29
	"\169050150255", -- builder 30
	"\169087000127", -- mage 31
	"\169000000000", -- black 32
	"\169050050050", -- not so black 33
	"\169103153112", -- sick 34
	"\169186140140", -- hotdog 35
	"\169163133104", -- pizza 36
	"\169170140070", -- menadione 37
	"\169255185185", -- bandage 38 /pink
	"\169228213179", -- shawarma 39
	"\169172137084", -- box 40
	"\169116088069", -- wood box 41
	"\169228213200", -- milk 42
	"\169255255120", -- cheese 43
	"\169171167146", -- onion 44
	"\169200010010", -- meat 45
	"\169096165077", -- dry rations 46
	"\169100070055", -- brown 47
	"\169221085175", -- jesters 48
	"\169255255000" -- yellow 49
}

local VJT=3
ProjectileTypes = {
	[1]={
		NAME=""..COLOUR[44].."LE Grenade",
		IMAGE="gfx/mora/cp/LEG.png",
		SPEED=5,
		DISTANCE=125,
		STATIC=false,
		BOUNCE=true,
		LIVETIME=1500,
		PLAYERSTOP=false,
		MODE="flying",
		ROT=5,
		EFFECT=function(ex,ey)
			parse("effect \"colorsmoke\" " .. ex .. " " .. ey .. " 1 1 075 075 075")
		end,
		ACTION=function(id,ex,ey,s)
			local damage=130
			local ranged=150
			parse("explosion ".. ex .." ".. ey .." ".. ranged .." ".. damage .." "..id.."")
		end
	},
	[2]={
		NAME=""..COLOUR[33].."Shuriken",
		IMAGE="gfx/mora/cp/SH.png",
		SPEED=16, 
		DISTANCE=130, 
		STATIC=true,
		MODE="flying",
		BOUNCE=false,
		LIVETIME=0, 
		PLAYERSTOP=true,
		ROT=5,
		ACTION=function(id,ex,ey,s)
			local damage=20
			if s~=0 then
				if player(s,"health")-calculateDMG(s,damage)<=0 then
					parse('customkill '..id..' \"Shuriken\" '..s)
				else
					parse('sethealth '..s..' '..player(s,'health')-calculateDMG(s,damage))
					if player(s,"armor")<=200 and player(s,"armor")>=1 then
						parse("setarmor "..s.." "..player(s,"armor")-damage)
					end
					parse('sv_soundpos "player/hit'..math.random(1,3)..'.wav" '..ex..' '..ey)
				end
			end
			parse("effect \"flare\" " .. ex .. " " .. ey .. " 1 1 255 255 255")
			parse('sv_soundpos "weapons/knife_hitwall.wav" '..ex..' '..ey)
		end
	},
	[3]={
		NAME=""..COLOUR[26].."Slime Bomb",
		IMAGE="gfx/mora/cp/SB.png",
		SPEED=4.5,
		DISTANCE=125,
		STATIC=false,
		BOUNCE=false,
		MODE="flying",
		LIVETIME=0,
		PLAYERSTOP=true,
		ROT=0,
		EFFECT=function(ex,ey)
			parse("effect \"flare\" " .. ex .. " " .. ey .. " 1 1 100 255 100")
		end,
		ACTION=function(id,ex,ey,s)
			local ranged=32
			local damage=50
			for _,k in pairs(player(0,"tableliving")) do
				if k~=id then
				local dist=math.sqrt(((player(k,"x")-ex)^2)+((player(k,"y")-ey)^2))
					if dist<=ranged then
						if (player(k,"health")-(calculateDMG(k,damage-dist)))<=0 then
							parse('customkill '..id..' \"Slime Bomb\" '..k)
						else
							if player(k,"armor")<=200 and player(k,"armor")>=1 then
								parse("setarmor "..k.." "..player(k,"armor")-damage-dist)
							end
							parse('sethealth '..k..' '..player(k,'health')-(calculateDMG(k,damage-dist)))
							parse('sv_soundpos "player/hit'..math.random(1,3)..'.wav" '..ex..' '..ey)
						end
					end
				end
			end
			parse('sv_soundpos "player/zm_hit.wav" '..ex..' '..ey)
			parse('sv_soundpos "materials/flesh2.wav" '..ex..' '..ey)
			parse("effect \"flare\" " .. ex .. " " .. ey .. " 5 16 0 255 0")
			parse("effect \"colorsmoke\" " .. ex .. " " .. ey .. " 3 16 050 255 050")
		end
	},
	[4]={
		NAME=""..COLOUR[23].."Hand-made molotov",
		IMAGE="gfx/mora/cp/MM.png",
		SPEED=5,
		DISTANCE=125, 
		STATIC=false,
		BOUNCE=false,
		MODE="flying_eff",
		LIVETIME=4000,
		PLAYERSTOP=false,
		ROT=5,
		EFFECT=function(ex,ey)
			parse("effect \"fire\" " .. ex .. " " .. ey .. " 1 1")
		end,
		ACTION=function(id,ex,ey,s,mode)
			local ranged=45
			local damage=50
			local firedmg=1
			if mode==1 then
				parse("explosion ".. ex .." ".. ey .." ".. ranged .." ".. damage .." "..id.."")
				parse('sv_soundpos "materials/glass'..math.random(1,3)..'.wav" '..ex..' '..ey)
			else
				if VJT==3 then
				parse('sv_soundpos "mora/cp/f.ogg" '..ex..' '..ey)
					for _,k in pairs(player(0,"tableliving")) do
					local dist=math.sqrt(((player(k,"x")-ex)^2)+((player(k,"y")-ey)^2))
						if dist<=ranged then
							local totaldmg=math.random(0,firedmg)
							if player(k,"health")-calculateDMG(k,totaldmg)<=0 then
								parse('customkill '..id..' \"Mini molotov\" '..k)
							else
								if player(k,"armor")<=200 and player(k,"armor")>=1 then
									parse("setarmor "..k.." "..player(k,"armor")-totaldmg)
								end
								parse('sethealth '..k..' '..player(k,'health')-calculateDMG(k,totaldmg))
								if totaldmg~=0 then
									parse('sv_soundpos "player/hit'..math.random(1,3)..'.wav" '..ex..' '..ey)
								end
							end
						end
					end
				end
			end
			parse("effect \"fire\" " .. ex .. " " .. ey .. " 1 "..ranged)
		end
	},
	[5]={
		NAME=""..COLOUR[27].."Hand-made gas grenade",
		IMAGE="gfx/mora/cp/MG.png",
		SPEED=5,
		DISTANCE=125, 
		STATIC=false,
		BOUNCE=true,
		MODE="flying_eff",
		LIVETIME=4000,
		PLAYERSTOP=false,
		ROT=3,
		EFFECT=function(ex,ey)
			parse("effect \"colorsmoke\" " .. ex .. " " .. ey .. " 1 1 075 075 075")
		end,
		ACTION=function(id,ex,ey,s,mode)
			local ranged=40
			local gasdmg=3
			if mode==1 then
				parse("effect \"smoke\" " .. ex .. " " .. ey .. " 3 16")
				parse('sv_soundpos "weapons/g_smoke.wav" '..ex..' '..ey)
			else
				if VJT==3 then
					for _,k in pairs(player(0,"tableliving")) do
						if not player(k,"gasmask") then
						local dist=math.sqrt(((player(k,"x")-ex)^2)+((player(k,"y")-ey)^2))
							if dist<=ranged then
								local totaldmg=math.random(0,gasdmg)
								if player(k,"health")-calculateDMG(k,totaldmg)<=0 then
									parse('customkill '..id..' \"Mini gas\" '..k)
								else
									if player(k,"armor")<=200 and player(k,"armor")>=1 then
										parse("setarmor "..k.." "..player(k,"armor")-totaldmg)
									end
									parse('sethealth '..k..' '..player(k,'health')-calculateDMG(k,totaldmg))
									if totaldmg~=0 then
										parse('sv_soundpos "player/hit'..math.random(1,3)..'.wav" '..ex..' '..ey)
									end
								end
							end
						end
					end
				end
			end
			parse("effect \"colorsmoke\" " .. ex .. " " .. ey .. " 1 "..ranged.." 160 140 070")
		end
	},
	[6]={
		NAME=""..COLOUR[40].."Small weight grenade",
		IMAGE="gfx/mora/cp/SWG.png",
		SPEED=7,
		DISTANCE=150, 
		STATIC=false,
		BOUNCE=false,
		MODE="flying",
		LIVETIME=0,
		PLAYERSTOP=false,
		ROT=5,
		EFFECT=function(ex,ey)
			parse("effect \"colorsmoke\" " .. ex .. " " .. ey .. " 1 1 075 075 075")
		end,
		ACTION=function(id,ex,ey,s)
			local ranged=70
			local damage=55
			parse("explosion ".. ex .." ".. ey .." ".. ranged .." ".. damage .." "..id.."")
		end
	},
	[7]={
		NAME=""..COLOUR[38].."Decoy",
		IMAGE="gfx/mora/cp/DC.png",
		SPEED=5.5,
		DISTANCE=125, 
		STATIC=false,
		BOUNCE=true,
		MODE="flying_eff",
		LIVETIME=5500,
		PLAYERSTOP=false,
		ROT=5,
		EFFECT=function(ex,ey)
			parse("effect \"colorsmoke\" " .. ex .. " " .. ey .. " 1 1 075 075 075")
		end,
		ACTION=function(id,ex,ey,s,mode)
			if mode==2 then
				if math.random(200)<=2 then
					local snd={"weapons/g_smoke","weapons/g_flash","weapons/deagle","weapons/usp","weapons/glock","weapons/knife_hitwall","weapons/explode1"}
					local random_snd=math.random(1,#snd)
					parse('sv_soundpos "'..snd[random_snd]..'.wav" '..ex..' '..ey)
				end
			end
		end
	},
	[8]={
		NAME=""..COLOUR[42].."Hand-made smoke",
		IMAGE="gfx/mora/cp/MS.png",
		SPEED=5,
		DISTANCE=125, 
		STATIC=false,
		BOUNCE=true,
		MODE="flying_eff",
		LIVETIME=8000,
		PLAYERSTOP=false,
		ROT=5,
		EFFECT=function(ex,ey)
			parse("effect \"colorsmoke\" " .. ex .. " " .. ey .. " 1 1 075 075 075")
		end,
		ACTION=function(id,ex,ey,s,mode)
			local smokerange=32
			local amount=2
			if mode==1 then
				parse('sv_soundpos "weapons/g_smoke.wav" '..ex..' '..ey)
			else
				parse("effect \"smoke\" " .. ex .. " " .. ey .. " "..amount.." "..smokerange.." 160 140 070")
				parse("effect \"colorsmoke\" " .. ex .. " " .. ey .. " "..(amount/2).." "..smokerange.." 0 0 0")
			end
		end
	},
	[9]={
		NAME=""..COLOUR[2].."Pillow",
		IMAGE="gfx/mora/cp/P.png",
		SPEED=4,
		DISTANCE=85,
		STATIC=false,
		BOUNCE=false,
		MODE="flying",
		LIVETIME=0,
		PLAYERSTOP=true,
		ROT=1,
		EFFECT=function(ex,ey)
			parse("effect \"flare\" " .. ex .. " " .. ey .. " 1 1 100 100 100")
		end,
		ACTION=function(id,ex,ey,s)
			local ranged=55
			local damage=20
			for _,k in pairs(player(0,"tableliving")) do
				if k~=id then
				local dist=math.sqrt(((player(k,"x")-ex)^2)+((player(k,"y")-ey)^2))
					if dist<=ranged then
						local totaldmg=math.random(damage-5,damage+5)
						if player(k,"health")-calculateDMG(k,totaldmg)<=0 then
							parse('customkill '..id..' \"Pillow\" '..k)
						else
							if player(k,"armor")<=200 and player(k,"armor")>=1 then
								parse("setarmor "..k.." "..player(k,"armor")-totaldmg)
							end
							parse('sethealth '..k..' '..player(k,'health')-calculateDMG(k,totaldmg))
							parse('sv_soundpos "player/hit'..math.random(1,3)..'.wav" '..ex..' '..ey)
						end
					end
				end
			end
			parse('sv_soundpos "mora/cp/p.ogg" '..ex..' '..ey)
			parse("effect \"colorsmoke\" " .. ex .. " " .. ey .. " 32 "..ranged.." 244 244 244")
		end
	},
	[10]={
		NAME=""..COLOUR[19].."Nokia 3310",
		IMAGE="gfx/mora/cp/N.png",
		SPEED=7, 
		DISTANCE=130, 
		STATIC=true,
		MODE="flying",
		BOUNCE=false,
		LIVETIME=0, 
		PLAYERSTOP=true,
		ROT=3,
		ACTION=function(id,ex,ey,s)
			local damage=55
			if s~=0 then
				if player(s,"health")-calculateDMG(s,damage)<=0 then
					parse('customkill '..id..' \"Nokia 3310\" '..s)
				else
					if player(s,"armor")<=200 and player(s,"armor")>=1 then
						parse("setarmor "..s.." "..player(s,"armor")-damage)
					end
					parse('sethealth '..s..' '..player(s,'health')-calculateDMG(s,damage))
					parse('sv_soundpos "player/hit'..math.random(1,3)..'.wav" '..ex..' '..ey)
					parse('shake '..s..' '..damage/2)
				end
			end
			parse("effect \"flare\" " .. ex .. " " .. ey .. " 1 1 120 180 255")
			parse('sv_soundpos "materials/glass'..math.random(1,3)..'.wav" '..ex..' '..ey)
		end
	},
	[11]={
		NAME=""..COLOUR[41].."Poop",
		IMAGE="gfx/mora/cp/PP.png",
		SPEED=7, 
		DISTANCE=100, 
		STATIC=true,
		MODE="flying",
		BOUNCE=false,
		LIVETIME=0, 
		PLAYERSTOP=true,
		ROT=0,
		EFFECT=function(ex,ey)
			parse("effect \"colorsmoke\" " .. ex .. " " .. ey .. " 1 1 120 90 70")
		end,
		ACTION=function(id,ex,ey,s)
			local damage=10
			if s~=0 then
				if player(s,"health")-calculateDMG(s,damage)<=0 then
					parse('customkill '..id..' \"Poop\" '..s)
				else
					if player(s,"armor")<=200 and player(s,"armor")>=1 then
						parse("setarmor "..s.." "..player(s,"armor")-damage)
					end
					parse('sethealth '..s..' '..player(s,'health')-calculateDMG(s,damage))
					parse('sv_soundpos "player/hit'..math.random(1,3)..'.wav" '..ex..' '..ey)
				end
			end
			parse("effect \"colorsmoke\" " .. ex .. " " .. ey .. " 1 1 70 40 20")
			parse("effect \"colorsmoke\" " .. ex .. " " .. ey .. " 1 1 120 90 70")
			parse('sv_soundpos "mora/cp/f'..math.random(1,3)..'.ogg" '..ex..' '..ey)
		end
	},
	[12]={
		NAME=""..COLOUR[20].."Menstruation blood",
		IMAGE="gfx/mora/cp/MB.png",
		SPEED=6, 
		DISTANCE=100, 
		STATIC=false,
		MODE="flying",
		BOUNCE=false,
		LIVETIME=0, 
		PLAYERSTOP=false,
		ROT=4,
		EFFECT=function(ex,ey)
			parse("effect \"flare\" " .. ex .. " " .. ey .. " 1 1 255 128 80")
		end,
		ACTION=function(id,ex,ey,s)
			local damage=30
			local ranged=45
			for _,k in pairs(player(0,"tableliving")) do
				if k~=id then
				local dist=math.sqrt(((player(k,"x")-ex)^2)+((player(k,"y")-ey)^2))
					if dist<=ranged then
						if player(k,"health")-calculateDMG(k,damage)<=0 then
							parse('customkill '..id..' \"Menstruation Blood\" '..k)
						else
							if player(k,"armor")<=200 and player(k,"armor")>=1 then
								parse("setarmor "..k.." "..player(k,"armor")-damage-dist)
							end
							parse('sethealth '..k..' '..player(k,'health')-calculateDMG(k,damage))
							parse('sv_soundpos "player/hit'..math.random(1,3)..'.wav" '..ex..' '..ey)
						end
					end
				end
			end
			parse("effect \"colorsmoke\" " .. ex .. " " .. ey .. " 8 "..ranged.." 255 0 0")
			parse("effect \"flare\" " .. ex .. " " .. ey .. " 2 2 255 128 80")
			parse('sv_soundpos "materials/glass'..math.random(1,3)..'.wav" '..ex..' '..ey)
		end
	},
	[13]={
		NAME=""..COLOUR[3].."Fireball",
		IMAGE="gfx/mora/cp/FB.png",
		SPEED=7,
		DISTANCE=150,
		STATIC=true,
		BOUNCE=false,
		MODE="flying",
		LIVETIME=0,
		PLAYERSTOP=true,
		ROT=14,
		EFFECT=function(ex,ey)
			parse("effect \"fire\" " .. ex .. " " .. ey .. " 1 1")
		end,
		ACTION=function(id,ex,ey,s)
			local damage=30
			if s~=0 then
				if player(s,"health")-calculateDMG(s,damage)<=0 then
					parse('customkill '..id..' \"Fireball\" '..s)
				else
					if player(s,"armor")<=200 and player(s,"armor")>=1 then
						parse("setarmor "..s.." "..player(s,"armor")-damage)
					end
					parse('sethealth '..s..' '..player(s,'health')-calculateDMG(s,damage))
					parse('sv_soundpos "player/hit'..math.random(1,3)..'.wav" '..ex..' '..ey)
					parse('shake '..s..' '..damage/2)
				end
			end
			parse('sv_soundpos "mora/cp/f.ogg" '..ex..' '..ey)
			parse("effect \"fire\" " .. ex .. " " .. ey .. " 3 1")
		end
	},
	[14]={
		NAME=""..COLOUR[44].."T"..COLOUR[20].."N"..COLOUR[44].."T",
		IMAGE="gfx/mora/cp/TNT.png",
		SPEED=4,
		DISTANCE=48,
		STATIC=false,
		BOUNCE=true,
		LIVETIME=5000,
		PLAYERSTOP=false,
		MODE="flying",
		ROT=3,
		EFFECT=function(ex,ey)
			parse("effect \"colorsmoke\" " .. ex .. " " .. ey .. " 1 1 075 075 075")
		end,
		ACTION=function(id,ex,ey,s)
			local damage=750
			local ranged=350
			parse("explosion ".. ex .." ".. ey .." ".. ranged .." ".. damage .." "..id.."")
		end
	},
	[15]={
		NAME=""..COLOUR[11].."Fragment",
		IMAGE="gfx/mora/cp/FG.png",
		SPEED=8, 
		DISTANCE=65, 
		STATIC=true,
		MODE="flying",
		BOUNCE=false,
		LIVETIME=0, 
		PLAYERSTOP=true,
		ROT=0,
		EFFECT=function(ex,ey)
			parse("effect \"colorsmoke\" " .. ex .. " " .. ey .. " 1 1 075 075 075")
		end,
		ACTION=function(id,ex,ey,s)
			local damage=11
			if s~=0 then
				local totaldmg=math.random(damage-2,damage+2)
				if player(s,"health")-calculateDMG(s,totaldmg)<=0 then
					parse('customkill '..id..' \"Fragment\" '..s)
				else
					if player(s,"armor")<=200 and player(s,"armor")>=1 then
						parse("setarmor "..s.." "..player(s,"armor")-totaldmg)
					end
					parse('sethealth '..s..' '..player(s,'health')-calculateDMG(s,totaldmg))
					parse('sv_soundpos "player/hit'..math.random(1,3)..'.wav" '..ex..' '..ey)
				end
			end
			parse('sv_soundpos "weapons/g_bounce.wav" '..ex..' '..ey)
		end
	},
	[16]={
		NAME=""..COLOUR[11].."Fragmentation Grenade",
		IMAGE="gfx/mora/cp/FGG.png",
		SPEED=5,
		DISTANCE=125,
		STATIC=false,
		BOUNCE=true,
		LIVETIME=2000,
		PLAYERSTOP=false,
		MODE="flying",
		ROT=5,
		EFFECT=function(ex,ey)
			parse("effect \"colorsmoke\" " .. ex .. " " .. ey .. " 1 1 075 075 075")
		end,
		ACTION=function(id,ex,ey,s)
			local damage=80
			local ranged=100
			local projtype=15
			for i=1,8 do
				spawn_projectile(projtype,ex,ey,(i*(360/8)-(360/8))+math.random(-20,20),math.random(ProjectileTypes[projtype].DISTANCE-10,ProjectileTypes[projtype].DISTANCE+10),id,ProjectileTypes[projtype].LIVETIME,ProjectileTypes[projtype].MODE,ProjectileTypes[projtype].ROT)
			end
			parse("explosion ".. ex .." ".. ey .." ".. ranged .." ".. damage .." "..id.."")
		end
	},
	[17]={
		NAME=""..COLOUR[2].."Keyboard",
		IMAGE="gfx/mora/cp/KB.png",
		SPEED=5.5,
		DISTANCE=90,
		STATIC=true,
		BOUNCE=true,
		LIVETIME=0,
		PLAYERSTOP=true,
		MODE="flying",
		ROT=7,
		ACTION=function(id,ex,ey,s)
			local damage=17
			if s~=0 then
				local totaldmg=math.random(damage-1,damage+2)
				if player(s,"health")-calculateDMG(s,totaldmg)<=0 then
					parse('customkill '..id..' \"Keyboard\" '..s)
				else
					if player(s,"armor")<=200 and player(s,"armor")>=1 then
						parse("setarmor "..s.." "..player(s,"armor")-totaldmg)
					end
					parse('sethealth '..s..' '..player(s,'health')-calculateDMG(s,totaldmg))
					parse('sv_soundpos "player/hit'..math.random(1,3)..'.wav" '..ex..' '..ey)
				end
			end
			parse("effect \"flare\" " .. ex .. " " .. ey .. " 4 8 222 222 222")
			parse('sv_soundpos "mora/cp/k'..math.random(1,4)..'.ogg" '..ex..' '..ey)
		end
	},
	[18]={
		NAME=""..COLOUR[47].."Stick",
		IMAGE="gfx/mora/cp/S.png",
		SPEED=11, 
		DISTANCE=125, 
		STATIC=true, 
		BOUNCE=true,
		LIVETIME=0, 
		PLAYERSTOP=true,
		MODE="flying",
		ROT=10,
		ACTION=function(id,ex,ey,s)
			local damage=6
			if s~=0 then
				local totaldmg=math.random(damage-1,damage+1)
				if player(s,"health")-calculateDMG(s,totaldmg)<=0 then
					parse('customkill '..id..' \"Stick\" '..s)
				else
					if player(s,"armor")<=200 and player(s,"armor")>=1 then
						parse("setarmor "..s.." "..player(s,"armor")-totaldmg)
					end
					parse('sethealth '..s..' '..player(s,'health')-calculateDMG(s,totaldmg))
					parse('sv_soundpos "player/hit'..math.random(1,3)..'.wav" '..ex..' '..ey)
				end
			end
			parse("effect \"colorsmoke\" " .. ex .. " " .. ey .. " 4 8 100 80 55")
			parse('sv_soundpos "materials/wood'..math.random(1,3)..'.wav" '..ex..' '..ey)
		end
	},
	[19]={
		NAME=""..COLOUR[12].."Dagger",
		IMAGE="gfx/mora/cp/D.png",
		SPEED=18, 
		DISTANCE=135, 
		STATIC=true, 
		BOUNCE=false,
		LIVETIME=0, 
		PLAYERSTOP=true,
		MODE="flying",
		ROT=0,
		ACTION=function(id,ex,ey,s)
			local damage=17
			if s~=0 then
				if player(s,"health")-calculateDMG(s,damage)<=0 then
					parse('customkill '..id..' \"Dagger\" '..s)
				else
					if player(s,"armor")<=200 and player(s,"armor")>=1 then
						parse("setarmor "..s.." "..player(s,"armor")-damage)
					end
					parse('sethealth '..s..' '..player(s,'health')-calculateDMG(s,damage))
					parse('sv_soundpos "player/hit'..math.random(1,3)..'.wav" '..ex..' '..ey)
				end
			end
			parse("effect \"smoke\" " .. ex .. " " .. ey .. " 1 1")
			parse('sv_soundpos "weapons/knife_hitwall.wav" '..ex..' '..ey)
		end
	},
	[20]={
		NAME=""..COLOUR[22].."Sock",
		IMAGE="gfx/mora/cp/SO.png",
		SPEED=5,
		DISTANCE=75, 
		STATIC=false,
		BOUNCE=false,
		MODE="flying_eff",
		LIVETIME=6000,
		PLAYERSTOP=true,
		ROT=9,
		EFFECT=function(ex,ey)
			parse("effect \"colorsmoke\" " .. ex .. " " .. ey .. " 1 1 075 100 075")
		end,
		ACTION=function(id,ex,ey,s,mode)
			local ranged=35
			local sockdmg=1
			if mode==1 then
				parse("effect \"smoke\" " .. ex .. " " .. ey .. " 3 16")
				parse('sv_soundpos "weapons/g_smoke.wav" '..ex..' '..ey)
			else
				if VJT==3 then
					for _,k in pairs(player(0,"tableliving")) do
						if not player(k,"gasmask") then
						local dist=math.sqrt(((player(k,"x")-ex)^2)+((player(k,"y")-ey)^2))
							if dist<=ranged then
								local totaldmg=math.random(0,sockdmg)
								if player(k,"health")-calculateDMG(k,totaldmg)<=0 then
									parse('customkill '..id..' \"Sock\" '..k)
								else
									if player(k,"armor")<=200 and player(k,"armor")>=1 then
										parse("setarmor "..k.." "..player(k,"armor")-totaldmg)
									end
									parse('sethealth '..k..' '..player(k,'health')-calculateDMG(k,totaldmg))
									if totaldmg~=0 then
										parse('sv_soundpos "player/hit'..math.random(1,3)..'.wav" '..ex..' '..ey)
									end
								end
							end
						end
					end
				end
			end
			parse("effect \"colorsmoke\" " .. ex .. " " .. ey .. " 1 "..ranged.." 075 100 075")
		end
	},
	[21]={
		NAME=""..COLOUR[33].."Hammer",
		IMAGE="gfx/mora/cp/H.png",
		SPEED=3,
		DISTANCE=60, 
		STATIC=true,
		BOUNCE=false,
		MODE="flying",
		LIVETIME=0,
		PLAYERSTOP=true,
		ROT=7,
		ACTION=function(id,ex,ey,s)
			local damage=350
			if s~=0 then
				if player(s,"health")-calculateDMG(s,damage)<=0 then
					parse('customkill '..id..' \"Hammer\" '..s)
				else
					if player(s,"armor")<=200 and player(s,"armor")>=1 then
						parse("setarmor "..s.." "..player(s,"armor")-damage)
					end
					parse('sethealth '..s..' '..player(s,'health')-calculateDMG(s,damage))
					parse('sv_soundpos "player/hit'..math.random(1,3)..'.wav" '..ex..' '..ey)
				end
			end
			parse("effect \"smoke\" " .. ex .. " " .. ey .. " 2 4")
			parse('sv_soundpos "materials/stone'..math.random(1,3)..'.wav" '..ex..' '..ey)
		end
	},
	[22]={
		NAME=""..COLOUR[45].."Brick",
		IMAGE="gfx/mora/cp/B.png",
		SPEED=4,
		DISTANCE=70, 
		STATIC=false,
		BOUNCE=false,
		MODE="flying",
		LIVETIME=0,
		PLAYERSTOP=true,
		ROT=2,
		ACTION=function(id,ex,ey,s)
			local damage=45
			if s~=0 then
				if player(s,"health")-calculateDMG(s,damage)<=0 then
					parse('customkill '..id..' \"Brick\" '..s)
				else
					if player(s,"armor")<=200 and player(s,"armor")>=1 then
						parse("setarmor "..s.." "..player(s,"armor")-damage)
					end
					parse('sethealth '..s..' '..player(s,'health')-calculateDMG(s,damage))
					parse('sv_soundpos "player/hit'..math.random(1,3)..'.wav" '..ex..' '..ey)
				end
			end
			parse("effect \"colorsmoke\" " .. ex .. " " .. ey .. " 2 4 150 010 010")
			parse("effect \"smoke\" " .. ex .. " " .. ey .. " 1 1")
			parse('sv_soundpos "materials/stone'..math.random(1,3)..'.wav" '..ex..' '..ey)
		end
	},
	[23]={
		NAME=""..COLOUR[36].."Axe",
		IMAGE="gfx/mora/cp/A.png",
		SPEED=5, 
		DISTANCE=130, 
		STATIC=true, 
		BOUNCE=false,
		LIVETIME=0, 
		PLAYERSTOP=true,
		MODE="flying",
		ROT=7,
		EFFECT=function(ex,ey)
			parse("effect \"smoke\" " .. ex .. " " .. ey .. " 1 1")
		end,
		ACTION=function(id,ex,ey,s)
			local damage=45
			if s~=0 then
				local totaldmg=math.random(damage-4,damage+4)
				if player(s,"health")-calculateDMG(s,totaldmg)<=0 then
					parse('customkill '..id..' \"Axe\" '..s)
				else
					if player(s,"armor")<=200 and player(s,"armor")>=1 then
						parse("setarmor "..s.." "..player(s,"armor")-totaldmg)
					end
					parse('sethealth '..s..' '..player(s,'health')-calculateDMG(s,totaldmg))
					parse('sv_soundpos "player/hit'..math.random(1,3)..'.wav" '..ex..' '..ey)
					parse('shake '..s..' '..damage/2)
				end
			end
			parse("effect \"flare\" " .. ex .. " " .. ey .. " 4 8 222 222 222")
			parse('sv_soundpos "weapons/machete_hitwall.wav" '..ex..' '..ey)
		end
	},
	[24]={
		NAME=""..COLOUR[48].."Jester's arrow",
		IMAGE="gfx/mora/cp/J.png",
		SPEED=9, 
		DISTANCE=145, 
		STATIC=true,
		MODE="flying",
		BOUNCE=false,
		LIVETIME=0, 
		PLAYERSTOP=true,
		ROT=0,
		EFFECT=function(ex,ey)
			parse("effect \"flare\" " .. ex .. " " .. ey .. " 2 32 221 085 175")
			parse("effect \"flare\" " .. ex .. " " .. ey .. " 2 32 236 198 175")
			parse("effect \"flare\" " .. ex .. " " .. ey .. " 2 32 090 128 255")
		end,
		ACTION=function(id,ex,ey,s)
			local damage=25
			if s~=0 then
				if player(s,"health")-calculateDMG(s,damage)<=0 then
					parse('customkill '..id..' \"Jester`s Arrow\" '..s)
				else
					if player(s,"armor")<=200 and player(s,"armor")>=1 then
						parse("setarmor "..s.." "..player(s,"armor")-damage)
					end
					parse('sethealth '..s..' '..player(s,'health')-calculateDMG(s,damage))
					parse('sv_soundpos "player/hit'..math.random(1,3)..'.wav" '..ex..' '..ey)
				end
			end
			parse("effect \"flare\" " .. ex .. " " .. ey .. " 3 16 221 085 175")
			parse("effect \"flare\" " .. ex .. " " .. ey .. " 3 16 236 198 175")
			parse("effect \"flare\" " .. ex .. " " .. ey .. " 3 32 090 128 255")
			parse('sv_soundpos "mora/cp/j.ogg" '..ex..' '..ey)
		end
	},
	[25]={
		NAME=""..COLOUR[1].."Holynade",
		IMAGE="gfx/mora/cp/HG.png",
		SPEED=6, 
		DISTANCE=125, 
		STATIC=false,
		MODE="flying_time",
		BOUNCE=true,
		LIVETIME=2200, 
		PLAYERSTOP=false,
		ROT=5,
		EFFECT=function(ex,ey)
			parse("effect \"flare\" " .. ex .. " " .. ey .. " 1 2 255 255 0")
		end,
		ACTION=function(id,ex,ey,s,mode)
			local flash=math.random(15,25)
			local damage=30
			local ranged=200
			if mode==1 then
				parse('sv_soundpos "mora/cp/HG.ogg" '..ex..' '..ey)
			else
				parse("effect \"flare\" " .. ex .. " " .. ey .. " 66 "..ranged.." 255 255 0")
				parse("effect \"flare\" " .. ex .. " " .. ey .. " 66 "..ranged.." 255 255 255")
				parse("explosion ".. ex .." ".. ey .." ".. ranged .." ".. damage .." "..id.."")
				parse("flashposition "..ex.." "..ey.." "..flash)
			end
		end
	},
	[26]={
		NAME=""..COLOUR[20].."Healing"..COLOUR[44].." syringe",
		IMAGE="gfx/mora/cp/HS.png",
		SPEED=2, 
		DISTANCE=48, 
		STATIC=true,
		MODE="flying",
		BOUNCE=false,
		LIVETIME=0, 
		PLAYERSTOP=true,
		ROT=0,
		ACTION=function(id,ex,ey,s)
			local hp=math.random(5,20)
			if s~=0 then
				parse('sethealth '..s..' '..player(s,'health')+hp)
				parse('sv_soundpos "player/hit'..math.random(1,3)..'.wav" '..ex..' '..ey)
			end
			parse("effect \"flare\" " .. ex .. " " .. ey .. " 2 1 255 0 0")
		end
	},
	[27]={
		NAME=""..COLOUR[13].."Missile",
		IMAGE="gfx/mora/cp/M.png",
		SPEED=7,
		DISTANCE=200, 
		STATIC=true,
		BOUNCE=false,
		MODE="flying",
		LIVETIME=0,
		PLAYERSTOP=true,
		ROT=0,
		CHECKDIST=200,
		CHECKANGLE=60,
		EFFECT=function(ex,ey)
			parse("effect \"fire\" " .. ex .. " " .. ey .. " 1 1")
		end,
		ACTION=function(id,ex,ey,s)
			local damage=48
			local ranged=35
			parse("explosion ".. ex .." ".. ey .." ".. ranged .." ".. damage .." "..id.."")
		end
	},
	[28]={
		NAME=""..COLOUR[49].."HR Missile",
		IMAGE="gfx/mora/cp/HR.png",
		SPEED=6,
		DISTANCE=170, 
		STATIC=true,
		BOUNCE=false,
		MODE="flying",
		LIVETIME=0,
		PLAYERSTOP=true,
		ROT=0,
		EFFECT=function(ex,ey)
			parse("effect \"fire\" " .. ex .. " " .. ey .. " 1 1")
		end,
		ACTION=function(id,ex,ey,s)
			local damage=25
			local ranged=150
			parse("explosion ".. ex .." ".. ey .." ".. ranged .." ".. damage .." "..id.."")
		end
	},
	[29]={
		NAME=""..COLOUR[27].."Duck",
		IMAGE="gfx/mora/cp/DK.png",
		SPEED=4,
		DISTANCE=125, 
		STATIC=true,
		BOUNCE=false,
		MODE="flying",
		LIVETIME=0,
		PLAYERSTOP=true,
		ROT=6,
		ACTION=function(id,ex,ey,s)
			local damage=50
			if s~=0 then
				if player(s,"health")-calculateDMG(s,damage)<=0 then
					parse('customkill '..id..' \"Duck\" '..s)
				else
					parse('sethealth '..s..' '..player(s,'health')-calculateDMG(s,damage))
					if player(s,"armor")<=200 and player(s,"armor")>=1 then
						parse("setarmor "..s.." "..player(s,"armor")-damage)
					end
					parse('sv_soundpos "player/hit'..math.random(1,3)..'.wav" '..ex..' '..ey)
				end
			end
			parse("effect \"flare\" " .. ex .. " " .. ey .. " 1 1 255 200 120")
			parse('sv_soundpos "mora/cp/g'..math.random(1,2)..'.ogg" '..ex..' '..ey)
		end
	},
	[30]={
		NAME=""..COLOUR[18].."Frog",
		IMAGE="gfx/mora/cp/FR.png",
		SPEED=4.5,
		DISTANCE=130, 
		STATIC=false,
		BOUNCE=false,
		MODE="flying",
		LIVETIME=0,
		PLAYERSTOP=true,
		ROT=6,
		ACTION=function(id,ex,ey,s)
			local damage=45
			if s~=0 then
				if player(s,"health")-calculateDMG(s,damage)<=0 then
					parse('customkill '..id..' \"Frog\" '..s)
				else
					parse('sethealth '..s..' '..player(s,'health')-calculateDMG(s,damage))
					if player(s,"armor")<=200 and player(s,"armor")>=1 then
						parse("setarmor "..s.." "..player(s,"armor")-damage)
					end
					parse('sv_soundpos "player/hit'..math.random(1,3)..'.wav" '..ex..' '..ey)
				end
			end
			parse("effect \"flare\" " .. ex .. " " .. ey .. " 1 1 200 255 20")
			parse('sv_soundpos "mora/cp/fr.ogg" '..ex..' '..ey)
		end
	},
}

function calculateDMG(id,dmg)
	if player(id,"health")~=0 then
		if player(id,"armor")==205 then
			dmg=dmg-0.95*dmg
		elseif player(id,"armor")==203 then
			dmg=dmg-0.75*dmg
		elseif player(id,"armor")==202 or player(id,"armor")==204 then
			dmg=dmg-0.5*dmg
		elseif player(id,"armor")==201 then
			dmg=dmg-0.25*dmg
		elseif player(id,"armor")<=200 and player(id,"armor")>=1 then
			local ap=player(id,"armor")
			if ap>dmg then
				ap=dmg
			end
			dmg=dmg-((dmg-(dmg-ap))*game("mp_kevlar"))
		end
	end
	return dmg
end

addhook("endround","_endround")
function _endround()
	freetimer()
	for k, v in pairs(Projectiles) do
		freeimage(v[2])
	end
	Projectiles={}
end

addhook("startround","_startround")
function _startround()
	freetimer()
	for k, v in pairs(Projectiles) do
		freeimage(v[2])
	end
	Projectiles={}
end

addhook("team","_team")
function _team(id)
	if not (type(PLAYERS[id])=="table") then
		PLAYERS[id]={
		GTYPE=1,
		INFO=true}
		update_text(id)
		if player(id,"usgn")~=0 then
			print(player(id,"name").." #"..player(id,"usgn"))
		end
	end
end

addhook("spawn","_spawn")
function _spawn(id)
	if player(id,"bot") then
		parse('speedmod '..id..' -200')
	end
end

addhook("leave","_leave")
function _leave(id,reason)
	if (type(PLAYERS[id])=="table") then
		PLAYERS[id]=nil
	end
	for k, v in pairs(Projectiles) do
		if v[8]==id then
			v[8]=0
		end
	end
end

function update_text(id)
	parse('hudtxt2 '..id..' 1 "'..ProjectileTypes[PLAYERS[id].GTYPE].NAME..' '..COLOUR[2]..'['..PLAYERS[id].GTYPE..' / '..#ProjectileTypes..']" 425 100 1')
	parse('hudtxt2 '..id..' 2 "'..COLOUR[2]..'['..COLOUR[3]..'E'..COLOUR[1]..' - throw'..COLOUR[2]..']['..COLOUR[4]..'F3'..COLOUR[1]..' +1'..COLOUR[2]..']['..COLOUR[19]..'F4'..COLOUR[1]..' -1'..COLOUR[2]..']['..COLOUR[12]..'F2'..COLOUR[1]..' - Hide/Display INFO'..COLOUR[2]..']" 425 116 1')
	if PLAYERS[id].INFO then
	parse('hudtxt2 '..id..' 3 "'..COLOUR[20]..'[Warning!!!]'..COLOUR[2]..' Using windowed mode with '..COLOUR[15]..'16'..COLOUR[2]..':'..COLOUR[15]..'9'..COLOUR[2]..' ratio and '..COLOUR[15]..'850'..COLOUR[2]..'x'..COLOUR[15]..'480'..COLOUR[2]..' screen size is recommended" 425 132 1')
	parse('hudtxt2 '..id..' 4 "'..COLOUR[3]..'[Also!]'..COLOUR[2]..' You may not hear some sounds of projectiles if you have limits! Options-Net-Download Files-ALL or atleast <500kb" 425 148 1')
	parse('hudtxt2 '..id..' 5 "'..COLOUR[18]..'[INFO]'..COLOUR[2]..' You can type in chat [/bind mouse2 use] without brackets, for better throwing with RMB" 425 164 1')
	else
	parse('hudtxt2 '..id..' 3 "" 425 132 1')
	parse('hudtxt2 '..id..' 4 "" 425 148 1')
	parse('hudtxt2 '..id..' 5 "" 425 148 1')
	end
end

function spawn_projectile(type,x,y,rot,range,id,livetime,state,imagerot)
	local img = image(ProjectileTypes[type].IMAGE,x,y,0)
	table.insert(Projectiles, {type, img, x, y, rot, ProjectileTypes[type].SPEED, range*3,id,livetime,state,ProjectileTypes[type].ROT})
end

function remove_projectile(id)
	for k, v in pairs(Projectiles) do
		if id == k then
			freeimage(v[2])
			Projectiles[id] = nil
		end
	end
end

addhook("clientdata","_clientdata")
function _clientdata(id,mode,ex,ey)
	if mode==2 then
		local range=math.sqrt(((ex-player(id,"x"))^2)+((ey-player(id,"y"))^2))/3
		if ProjectileTypes[PLAYERS[id].GTYPE].STATIC then
			range=ProjectileTypes[PLAYERS[id].GTYPE].DISTANCE
		else
			if range>ProjectileTypes[PLAYERS[id].GTYPE].DISTANCE then
				range=ProjectileTypes[PLAYERS[id].GTYPE].DISTANCE
			end
		end
		local livetime=0
		if ProjectileTypes[PLAYERS[id].GTYPE].LIVETIME~=0 then
			livetime=ProjectileTypes[PLAYERS[id].GTYPE].LIVETIME
		end
		spawn_projectile(PLAYERS[id].GTYPE,player(id,"x"),player(id,"y"),player(id,"rot"),range,id,livetime,ProjectileTypes[PLAYERS[id].GTYPE].MODE,0)
	end
end

addhook("use","_use")
function _use(id)
	if player(id,"health")>0 then
		reqcld(id,2)
	end
end

addhook("serveraction","_sv")
function _sv(id,a)
	if a==1 then
		if PLAYERS[id].INFO then
			PLAYERS[id].INFO=false
			update_text(id)
		else
			PLAYERS[id].INFO=true
			update_text(id)
		end
	elseif a==2 then
		if PLAYERS[id].GTYPE+1~=(#ProjectileTypes)+1 then
			PLAYERS[id].GTYPE=PLAYERS[id].GTYPE+1
			update_text(id)
		end
	elseif a==3 then
		if PLAYERS[id].GTYPE-1~=0 then
			PLAYERS[id].GTYPE=PLAYERS[id].GTYPE-1
			update_text(id)
		end
	end
end

function plc(t,x,y)
	local pid=0
	for _,id in pairs(player(0,"tableliving")) do
		if id ~= Projectiles[t][8] then
			if x>=player(id,"x")-10 and x<=player(id,"x")+10 and y>=player(id,"y")-10 and y<=player(id,"y")+10 then			
				return id
			end
		end
	end
	return 0
end

function clp(t,x,y)
	local closestp=0
	local closedist=999999
	for _,id in pairs(player(0,"tableliving")) do
		if id ~= Projectiles[t][8] then
			local checkdist=math.sqrt(((x-player(id,"x"))^2)+((y-player(id,"y"))^2))
			if ProjectileTypes[Projectiles[t][1]].CHECKDIST>=checkdist then
				if checkdist<closedist then
					closedist=checkdist
					closestp=id
				end
			end
		end
	end
	local pr_rot = 0
	local angle=0
	if closestp~=0 then
		pr_rot = -math.deg(math.atan2((x-player(closestp,"x")), (y-player(closestp,"y"))))
		if math.rad(Projectiles[t][5])<math.rad(pr_rot) then
			angle = Projectiles[t][5]+ProjectileTypes[Projectiles[t][1]].ROT
		elseif math.rad(Projectiles[t][5])>math.rad(pr_rot) then
			angle = Projectiles[t][5]-ProjectileTypes[Projectiles[t][1]].ROT
		elseif math.rad(ProjectileTypes[t][5])==math.rad(pr_rot) then
			angle = pr_rot
		else
			angle = Projectiles[t][5]
		end
	end
	return {closestp, angle}
end

addhook("always","update_projectiles")
function update_projectiles()
if VJT-1>0 then
	VJT=VJT-1
else
	VJT=3
end
	for k, v in pairs(Projectiles) do
		local s=0
		local closestp=0
		if v[7] > 0 then
			v[7] = v[7] - v[6]
			if v[10]=="flying_time" then
				v[9] = v[9] - v[6]
			end
			
			  local ex = v[3] + math.cos(math.rad(v[5]-90))*v[6] -- New position of projectile on X axis
			  local ey = v[4] + math.sin(math.rad(v[5]-90))*v[6]
				if not (tile(math.floor(ex/32),math.floor(ey/32),"wall")) then
					if ProjectileTypes[v[1]].ROT==0 then
						v[11]=v[5]
					else
						if v[10]=="flying_p" then
							local closestp=clp(k,v[3],v[4])
							if closestp[1]~=0 then
								v[5]=closestp[2]
								ex = v[3] + math.cos(math.rad(v[5]-90))*v[6]
								ey = v[4] + math.sin(math.rad(v[5]-90))*v[6]
							end
							v[11]=v[5]
						else
							v[11]=v[11]+ProjectileTypes[v[1]].ROT
						end
					end
					v[3], v[4] = ex, ey
					imagepos(v[2],ex,ey,v[11])
					if VJT==3 then
						if ProjectileTypes[v[1]].EFFECT then ProjectileTypes[v[1]].EFFECT(v[3], v[4]) end
					end
					if ProjectileTypes[v[1]].PLAYERSTOP then
						s=plc(k,v[3],v[4])
						if s~=0 then
							if v[10]=="flying_eff" then
								ProjectileTypes[v[1]].ACTION(v[8], v[3], v[4], s, 1)
								v[10]="ground_eff"
								v[7]=0
								timer(v[9]+1,"parse","lua remove_projectile("..k..")")
							elseif v[10]=="ground_eff" then
								ProjectileTypes[v[1]].ACTION(v[8], v[3], v[4], s, 2)
							else
								ProjectileTypes[v[1]].ACTION(v[8], v[3], v[4], s)
								remove_projectile(k)
							end
						end							
					end
				else
					if ProjectileTypes[v[1]].BOUNCE then
						v[5]=-v[5]
						local ex = v[3] + math.cos(math.rad(v[5]-90))*v[6] -- New position of projectile on X axis
						local ey = v[4] + math.sin(math.rad(v[5]-90))*v[6]
						if tile(math.floor(ex/32),math.floor(ey/32),"wall") then
							v[5]=v[5] + 180
						end
						v[3] = v[3] + math.cos(math.rad(v[5]-90))*v[6]
						v[4] = v[4] + math.sin(math.rad(v[5]-90))*v[6]
						if ProjectileTypes[v[1]].ROT==0 then
							v[11]=v[5]
						else
							v[11]=v[11]+ProjectileTypes[v[1]].ROT
						end
						imagepos(v[2],v[3],v[4],v[11])
						parse('sv_soundpos "weapons/g_bounce.wav" '..ex..' '..ey)
						if VJT==3 then
							if ProjectileTypes[v[1]].EFFECT then ProjectileTypes[v[1]].EFFECT(v[3], v[4]) end
						end
					else
						if v[10]=="flying_eff" then
							ProjectileTypes[v[1]].ACTION(v[8], v[3], v[4], s, 1)
							v[10]="ground_eff"
							timer(v[9]+1,"parse","lua remove_projectile("..k..")")
						elseif v[10]=="ground_eff" then
							ProjectileTypes[v[1]].ACTION(v[8], v[3], v[4], s, 2)
						else
							ProjectileTypes[v[1]].ACTION(v[8], v[3], v[4], s)
							remove_projectile(k)
						end
					end
				end
		else
			if ProjectileTypes[v[1]].LIVETIME==0 then
				if ProjectileTypes[v[1]].ACTION then ProjectileTypes[v[1]].ACTION(v[8], v[3], v[4], s) end
				remove_projectile(k)
			else
				if ProjectileTypes[v[1]].ACTION then
					if v[10]=="flying" then
					v[10]="ground"
					timer(v[9],"parse","lua ProjectileTypes["..v[1].."].ACTION("..v[8]..","..v[3]..","..v[4]..","..s..")")
					timer(v[9]+1,"parse","lua remove_projectile("..k..")")
					elseif v[10]=="flying_eff" then
						ProjectileTypes[v[1]].ACTION(v[8], v[3], v[4], s, 1)
						v[10]="ground_eff"
						timer(v[9]+1,"parse","lua remove_projectile("..k..")")
					elseif v[10]=="ground_eff" then
						ProjectileTypes[v[1]].ACTION(v[8], v[3], v[4], s, 2)
					elseif v[10]=="flying_time" then
						v[10]="ground_time"
						ProjectileTypes[v[1]].ACTION(v[8], v[3], v[4], s, 1)
						timer(v[9],"parse","lua ProjectileTypes["..v[1].."].ACTION("..v[8]..","..v[3]..","..v[4]..","..s..",2)")
						timer(v[9]+1,"parse","lua remove_projectile("..k..")")
					end
				end
			end
		end
	end
end